#ifdef __cplusplus
     #define EXPORTS extern "C" __declspec (dllimport)
#else
     #define EXPORTS
#endif


#define    Data5Bit                     5
#define    Data6Bit                     6
#define    Data7Bit                     7
#define    Data8Bit                     8

#define    NonParity                    0
#define    OddParity                    1
#define    EvenParity                   2

#define    OneStopBit                   0
#define    One5StopBit                  1
#define    TwoStopBit                   2

// return code
#define    NoError                      0
#define    FunctionError                1
#define    PortError                    2
#define    BaudRateError                3
#define    DataError                    4
#define    StopError                    5
#define    ParityError                  6
#define    CheckSumError                7
#define    ComPortNotOpen               8
#define    SendThreadCreateError        9
#define    SendCmdError                 10
#define    ReadComStatusError           11
#define    ResultStrCheckError          12
#define    CmdError                     13
#define    TimeOut                      15
#define    ModuleIdError                17
#define    AdChannelError               18
#define    UnderInputRange              19
#define    ExceedInputRange             20
#define    InvalidateCounterNo          21
#define    InvalidateCounterValue       22
#define    InvalidateGateMode           23
#define    InvalidateChannelNo          24


EXPORTS WORD  CALLBACK Open_Com(char cPort, DWORD dwBaudRate, 
              char cData, char cParity, char cStop);
EXPORTS BOOL  CALLBACK Close_Com(char cPort);

EXPORTS WORD  CALLBACK ComPortStatus(char port);
//  1: this port is used now
//  0: this port isn't used now

EXPORTS WORD  CALLBACK Send_Receive_Cmd(char cPort, char szCmd[], 
              char szResult[], WORD wTimeOut, WORD wChksum, WORD *wT);

EXPORTS WORD  CALLBACK Send_Cmd(char cPort, char szCmd[], 
              WORD wTimeout, WORD wChkSum);
EXPORTS WORD  CALLBACK Receive_Cmd(char cPort, char szResult[], 
              WORD wTimeOut, WORD wChkSum, WORD *wT);

EXPORTS WORD  CALLBACK Send_Str(char cPort, char szCmd[], WORD wTimeOut);
EXPORTS WORD  CALLBACK Receive_Str(char cPort, char szResult[], 
              WORD wTimeOut, WORD wLen, WORD *wT);

//---------------------------------------------------------------------------


EXPORTS WORD  CALLBACK Get_Dll_Version(void);


EXPORTS WORD CALLBACK Test(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
// for driver testing
// strcpy(szSendTo9000,"Command String Send to EX9000");
// strcpy(szReceiveFrom9000,"Command String Receive From EX9000");
// for (i=0; i<4; i++)
//     {
//    wIPBUF[i]++;
//    fOPBUF[i]++;
//    }

EXPORTS WORD CALLBACK HostIsOK(WORD wIPBUF[], float fOPBUF[],
      char szSendTo9000[], char szReceiveFrom9000[]);

/*--- Read the module reset status, $AA5 --------*/
EXPORTS WORD CALLBACK ReadModuleResetStatus(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -----------------------------------
//  wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//  wIPBUF[1];   // 00 to FF : for module address 
//  wIPBUF[2];   // dosen't matter
//  wIPBUF[3];   // 0=disable, 1=enable : for checksum
//  wIPBUF[4];   // normal=100 : for TimeOut constant 
//  wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//---------------------- output ----------------------------------
//  wIPBUF[5];   // wIPBUF[5]=0: for module has not been reset
                    // wIPBUF[5]=1: for module has been reset

/*--- To setup host watchdog, ~AA3ETT --------*/
EXPORTS WORD CALLBACK ToSetupHostWatchdog(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -----------------------------------
//  wIPBUF[0];   // 1/2/3/4 : for RS-232 port number
//  wIPBUF[1];   // 00 to FF : for module address
//  wIPBUF[2];   // dosen't matter
//  wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//  wIPBUF[4];   // normal=100 : for TimeOut constant
//  wIPBUF[5];   // 0: for Disable host watchdog
                 // 1: for Enable host watchdog
//  wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//  wIPBUF[7];   // unit is 0.1 second, a time interval for watchdog, 
                // e.x  the time interval is 4.5 second when Wipbuf[7]=45

/*--- To read host watchdog setup value, ~AA2 --------*/
EXPORTS WORD CALLBACK ToReadHostWatchdog(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -----------------------------------
//  wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//  wIPBUF[1];   // 00 to FF : for module address 
//  wIPBUF[2];   // dosen't matter 
//  wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//  wIPBUF[4];   // normal=100 : for TimeOut constant
//  wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//---------------- output -----------------------------------
//  wIPBUF[5];   // 0: for Disable host watchdog
                    // 1: for Enable host watchdog
//  wIPBUF[7];   // unit is 0.1 second, a time interval for watchdog, 
                // e.x  the time interval is 4.5 second when Wipbuf[7]=45




/*--- Read the module status about the host watchdog, ~AA0 --------*/
EXPORTS WORD CALLBACK ReadModuleHostWatchdogStatus(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -----------------------------------
//  wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//  wIPBUF[1];   // 00 to FF : for module address 
//  wIPBUF[2];   // dosen't matter 
//  wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//  wIPBUF[4];   // normal=100 : for TimeOut constant
//  wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//---------------------- output ----------------------------------
//  wIPBUF[5];   // wIPBUF[5]=0:  for module is OK
                   //  wIPBUF[5]=4:  for host watchdog failure

/*--- Reset the module status about the host watchdog, ~AA1 --------*/
EXPORTS WORD CALLBACK ResetModuleHostWatchdogStatus(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -----------------------------------
//  wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//  wIPBUF[1];   // 00 to FF : for module address 
//  wIPBUF[2];   // dosen't matter 
//  wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//  wIPBUF[4];   // normal=100 : for TimeOut constant
//  wIPBUF[5];   // dosen't matter 
//  wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string



/*--Set SafeValue for all DO module(42/43/44/50/60/65/67) ---*/
EXPORTS WORD CALLBACK SetSafeValueForDo(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input ---------------------------
//  wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//  wIPBUF[1];   // 00 to FF : for module address 
//  wIPBUF[2];   // module ID: for 0x9050/60/67/42/43/44
//  wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//  wIPBUF[4];   // normal=100 : for TimeOut constant
//  wIPBUF[5];   // safe value
//  wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string


/*--Set PowerOn value for all DO module(42/43/44/50/60/65/67) ---*/
EXPORTS WORD CALLBACK SetPowerOnValueForDo(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//  wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//  wIPBUF[1];   // 00 to FF : for module address 
//  wIPBUF[2];   // module ID: for 0x9050/60/67/42/43/44
//  wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//  wIPBUF[4];   // normal=100 : for TimeOut constant
//  wIPBUF[5];   // PowerOn value
//  wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 

/*--Set SafeValue for all Ao module(21/24), ~AA5 ---*/
EXPORTS WORD CALLBACK SetSafeValueForAo(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input ---------------------------
//  wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//  wIPBUF[1];   // 00 to FF : for module address 
//  wIPBUF[2];   // module ID: 0x9021/0x9024
//  wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//  wIPBUF[4];   // normal=100 : for TimeOut constant
//  wIPBUF[5];   // Channel No
//  wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//  fOPBUF[0];   // safe value

/*--Set PowerOn value for all Ao module(21/24), $AA4 ---*/
EXPORTS WORD CALLBACK SetPowerOnValueForAo(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//  wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//  wIPBUF[1];   // 00 to FF : for module address 
//  wIPBUF[2];   // module ID: for 0x9021/0x9024
//  wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//  wIPBUF[4];   // normal=100 : for TimeOut constant
//  wIPBUF[5];   // PowerOn value
//  wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//  fOPBUF[0];   // PowerOn value


/*-------- 9011/9012/9014 Set PowerOn/Safe value --------*/
EXPORTS WORD CALLBACK SetPowerOnSafeValue(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//  wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//  wIPBUF[1];   // 00 to FF : for module address 
//  wIPBUF[2];   // module ID: for 0x9011/0x9012/0x9014
//  wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//  wIPBUF[4];   // normal=100 : for TimeOut constant
//  wIPBUF[5];   // PowerOn value
//  wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//  wIPBUF[7];   // safe value

/*--Read PowerOn value for all DO module(42/43/44/50/60/65/67) ---*/
EXPORTS WORD CALLBACK ReadPowerOnValueForDo(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input ---------------------------
// wIPBUF[0];    // 1/2/3/4 : for RS-232 port number
// wIPBUF[1];    // 00 to FF : for module address 
//wIPBUF[2];    // module ID: for 0x9050/60/65/67/42/43/44
// wIPBUF[3];    // 0=disable, 1=enable : for checksum 
// wIPBUF[4];    // normal=100 : for TimeOut constant
// wIPBUF[6];    // 0=no save, 1=save : for flag send/receive string
//---------------------- output -----------------------
//   wIPBUF[5]:   PowerOn Value 


/*--Read SafeValue for all DO module(42/43/44/50/60/65/67) ---*/
EXPORTS WORD CALLBACK ReadSafeValueForDo(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input ---------------------------
// wIPBUF[0];    // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];    // 00 to FF : for module address 
// wIPBUF[2];    // module ID: for 0x9050/60/65/67/42/43/44
// wIPBUF[3];    // 0=disable, 1=enable : for checksum 
// wIPBUF[4];    // normal=100 : for TimeOut constant
// wIPBUF[6];    // 0=no save, 1=save : for flag send/receive string 
//---------------------- output -----------------------
//   wIPBUF[5]:   Safe Value Value


/*-------- Read Config Status ---------*/
EXPORTS WORD CALLBACK  ReadConfigStatus(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];   // 00 to FF : for module address 
// wIPBUF[2];   // module ID
// wIPBUF[3];   // 0=disable, 1=enable : for checksum
// wIPBUF[4];   // normal=100 : for TimeOut constant
// wIPBUF[5];   // dosen't matter 
// wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//---------------------- Output -------------------------------------
// wIPBUF[7]:   module address
// wIPBUF[8]:   module Range Code
// wIPBUF[9]:   module baudrate
// wIPBUF[10]:  module data format


EXPORTS WORD CALLBACK AnalogIn(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9011/12/13/14/16/17/18/33
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // channel number for multi-channel
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 
//---------------------- output ------------------------------------
                         // fOPBUF[0]=analog input value

EXPORTS WORD CALLBACK AnalogInFsr(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9011/12/13/14/17/18
// wIPBUF[3];             // 0=disable, 1=enable : for checksum
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // channel number for multi-channel
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 
//---------------------- output ------------------------------------
                         // fOPBUF[0]=analog input value in %FSR format


EXPORTS WORD CALLBACK AnalogInHex(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9011/12/13/14/17/18
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // channel number for multi-channel
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string
//---------------------- output ------------------------------------
                         // wIPBUF[7] : analog input value



EXPORTS WORD CALLBACK AnalogIn8(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9017/18
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string
//---------------------- output ------------------------------------
                         // fOPBUF[0]=analog input value of channel_0
                         // fOPBUF[1]=analog input value of channel_1
                         // ........................................
                         // fOPBUF[7]=analog input value of channel_7


EXPORTS WORD CALLBACK In8_9017(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module Type: for 08/09/0A/0B/0C/0D
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 
//---------------------- output ------------------------------------
                         // fOPBUF[0]=analog input value of channel_0
                         // fOPBUF[1]=analog input value of channel_1
                         // ........................................
                         // fOPBUF[7]=analog input value of channel_7


EXPORTS WORD CALLBACK AnalogOut(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];   // 00 to FF : for module address 
// wIPBUF[2];   // module ID: for 0x9016/21/24
// wIPBUF[3];   // 0=disable, 1=enable : for checksum 
// wIPBUF[4];   // normal=100 : for TimeOut constant
// wIPBUF[5];   // Not used if module ID is 9016/9021
                           // Channel No.(0 to 3) if module ID is 9024
// wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
// fOPBUF[0];   // analog output value
//---------------------- output ------------------------------------
                           // void

EXPORTS WORD CALLBACK AnalogOutReadBack(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];  // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];  // 00 to FF : for module address 
// wIPBUF[2];  // module ID: for 0x9021 or 0x9024
// wIPBUF[3];  // 0=disable, 1=enable : for checksum 
// wIPBUF[4];  // normal=100 : for TimeOut constant
// wIPBUF[5];  // When 9016: dosen't matter 
              // When 9021/9024
              //   0: command read back ($AA6)
              //   1: when module ID is 0x9021
              //        analog output of current path read back ($AA8)
              //        when module ID is 0x9024
              //        the updating value in a specific Slew rate($AA8)
              //        (see 9024 manual for more detail information)
// wIPBUF[6];  // 0=no save, 1=save : for flag send/receive string
// wIPBUF[7];  // Channel No.(0 to 3), if module ID is 9024
              //   Not used,        else
//---------------------- output ------------------------------------
              //   fOPBUF[0]=analog output value read back


EXPORTS WORD CALLBACK DigitalOut(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9050/60/63/65/66/67/42/43/44/11/12/14/80
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // 16-bit digital data to output
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string
//---------------------- output ------------------------------------
                         // void

EXPORTS WORD CALLBACK DigitalBitOut(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9050/60/63/65/66/67/42/43/44
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // don't care
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string
// wIPBUF[7];             // which channel to output
// wIPBUF[8];             // data to output (0 or 1)
//---------------------- output ------------------------------------
                         // void

EXPORTS WORD CALLBACK DigitalOut_9016(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9016
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // 2-bit digital data to output
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 
// wIPBUF[7];             // 0: for Bit0, Bit1 output
                          // 1: for Bit2, Bit3 output
//---------------------- output ------------------------------------
                         // void

EXPORTS WORD CALLBACK DigitalOutReadBack(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9050/60/67/42/43/44
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string
//---------------------- output ------------------------------------
                         // wIPBUF[5]=digital output data read back


EXPORTS WORD CALLBACK DigitalIn(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9050/52/53/60/63/65/41/44/11/12/14/16
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string
//---------------------- output ------------------------------------
                         // wIPBUF[5]=digital input data

EXPORTS WORD CALLBACK DigitalInCounterRead(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9050/52/53/60/63/65/41/44
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // Channel Number
// wIPBUF[6];             //0=no save, 1=save : for flag send/receive string
//---------------------- output ------------------------------------
// wIPBUF[7]=Counter Value of Channel N's Digital Input


EXPORTS WORD CALLBACK ClearDigitalInCounter(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9050/52/53/60/63/65/41/44
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // Channel Number
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string


EXPORTS WORD CALLBACK DigitalInLatch(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9050/52/53/60/63/65/41/44
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // 0: Latch Low,   1: Latch High
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string
//---------------------- output ------------------------------------
// wIPBUF[7];             // latch value


EXPORTS WORD CALLBACK ClearDigitalInLatch(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9050/52/53/60/63/65/41/44
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // dosen't matter 
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string

/*-------- 9011 Thermocouple Open Detection ---------*/
EXPORTS WORD CALLBACK ThermocoupleOpen_9011(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9011
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//---------------------- output ------------------------------------
//wIPBUF[5]   0: Close     1: Open


/*----- 9011/9012/9014 Set Power On and Safe value ---------*/
EXPORTS WORD CALLBACK SetPowerOnAndSafeValue(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9011
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // 0xPPSS:  for PP=Power On value , SS=safe value
              //              00: DO0 -> Off   DO1 -> Off
              //              01: DO0 -> On    DO1 -> Off
              //              02: DO0 -> Off   DO1 -> On
              //              03: DO0 -> On    DO1 -> On
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string



/*----- 9011/9012/9014 Enable Alarm ---------*/
EXPORTS WORD CALLBACK EnableAlarm(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9011
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // 0: for Momentary,  1: for Latch
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string


/*----- 9011/9012/9014 Disable Alarm ---------*/
EXPORTS WORD CALLBACK DisableAlarm(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9011/0x9012/0x9014
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // dosen't matter 
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 


/*-------- 9011/9012/9014/9016 Clear Latch Alarm ---------*/
EXPORTS WORD CALLBACK ClearLatchAlarm(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9011
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant, 0.1 second
//wIPBUF[5];   // dosen't matter 
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string


/*--- 9011/9012/9014/9016 Set Hi/Lo Alarm Limit Value ------*/
/*******************************************************/
/* please get the module's range code by calling       */
/* ReadConfigStatus(.......) function before           */
/* calling SetAlarmLimitValue(......).                 */
/*******************************************************/
EXPORTS WORD CALLBACK SetAlarmLimitValue(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9011
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant, 0.1 second
//wIPBUF[5];   // 0: for Lo Alarm     1: for Hi Alarm
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//wIPBUF[7];   // module's range code 
//fOPBUF[0]:   // Alarm Limit of Value

/*-------- 9011/9012/9014/9016 Read Hi/Lo Alarm Limit Value ---------*/
EXPORTS WORD CALLBACK ReadAlarmLimitValue(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input ----------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9011
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant, 0.1 second
//wIPBUF[5];   // 0: for Lo Alarm     1: for Hi Alarm
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//---------------------- output ---------------------------------
//fOPBUF[0]:   // Alarm Limit of Value

/*---- Read Alarm State and Digital Output State ---------*/
EXPORTS WORD CALLBACK ReadOutputAlarmState(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // dosen't matter 
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//---------------------- output ------------------------------------
//               Alarm State:
// wIPBUF(7):0       Disable
// wIPBUF(7):1       Momentary
// wIPBUF(7):2       Latch
//               Digital Output
// wIPBUF(8)    -> a decimal number to represent the digital output status


/*-------- 9011/9012/9014 Read Event Counter --------*/
EXPORTS WORD CALLBACK ReadEventCounter(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // dosen't matter 
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//---------------------- output ------------------------------------
//wIPBUF[7];   // The Event Counter of Value

/*-------- 9011/9012/9014/9016 Clear Event Counter --------*/
EXPORTS WORD CALLBACK ClearEventCounter(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // dosen't matter 
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string

/*-------- Set LED channel Display for 9033 --------*/
EXPORTS WORD CALLBACK SetLedDisplay_9033(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // set display channel for 9033, 0<=channel<=2
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 

/*-------- Get LED channel Display for 9033 --------*/
EXPORTS WORD CALLBACK GetLedDisplay_9033(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant 
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//----------------------- output -----------------------------------
//wIPBUF[5];   // which channel to display

/**********************************************************/
/*-------- Set LED channel Display for 9016, 9033 --------*/
EXPORTS WORD CALLBACK SetLedDisplay(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // set display channel for 9013, 9033
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 

/*-------- Get LED channel Display for 9016, 9033 --------*/
EXPORTS WORD CALLBACK GetLedDisplay(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//----------------------- output -----------------------------------
//wIPBUF[5];   // which channel to display


/*******************************************************/
/* please get the module's range code by calling       */
/* ReadConfigStatus(.......) function before           */
/* calling SetupLinearMapping(......).                 */
/*-------- setup linear mapping for 9014/9016 ---------*/
/*  making a linear mapping from [a,b] to [c,d]        */
/*  where:  fOPBUF[0]=a,  fOPBUF[1]=b                    */
/*          fOPBUF[2]=c,  fOPBUF[3]=d                    */
/*******************************************************/
EXPORTS WORD CALLBACK SetupLinearMapping(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9014, 0x9016
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant, 0.1 second
//wIPBUF[5];   // dosen't matter
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//wIPBUF[7];   // range code of this module
//fOPBUF[0]:   // a for source low value,  
//fOPBUF[1];   // b for source high value, 
//fOPBUF[2];   // c for target low value,  
//fOPBUF[3];   // d for target high value, 

/*----- Enable linear mapping for 9014/9016 ---------*/
EXPORTS WORD CALLBACK EnableLinearMapping(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9014, 0x9016
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant, 0.1 second
//wIPBUF[5];   // dosen't matter 
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 

/*----- Disable linear mapping for 9014/9016 ---------*/
EXPORTS WORD CALLBACK DisableLinearMapping(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9014, 0x9016
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant, 0.1 second
//wIPBUF[5];   // dosen't matter 
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 

/*----- Reading Linear Mapping Status for 9014/9016 -----*/
EXPORTS WORD CALLBACK ReadLinearMappingStatus(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9014, 0x9016
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant, 0.1 second
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//--------------------- output -------------------------------------
//wIPBUF[5];   // 0: for linear mapping is disable
               // 1: for linear mapping is enable

/*----- Reading Source Value of Linear Mapping for 9014/9016 -----*/
EXPORTS WORD CALLBACK ReadSourceValueOfLM(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9014, 0x9016
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant, 0.1 second
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//--------------------- output -------------------------------------
//fOPBUF[0];   // for Low Source Value
//fOPBUF[1];   // for High Source Value

/*----- Reading Target Value of Linear Mapping for 9014/9016 -----*/
EXPORTS WORD CALLBACK ReadTargetValueOfLM(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9014, 0x9016
//wIPBUF[3];   // 0=disable, 1=enable : for checksum  
//wIPBUF[4];   // normal=100 : for TimeOut constant, 0.1 second
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//--------------------- output -------------------------------------
//fOPBUF[0];   // for Low Target Value
//fOPBUF[1];   // for High Target Value

/**************************************************************************/
EXPORTS WORD CALLBACK CounterIn_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // 0: for Counter 0,  1: for Counter 1
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string
//---------------------- output ------------------------------------
                         // wIPBUF[7]  Hi-Word of counter value
                         // wIPBUF[8]  Lo-Word of counter value


EXPORTS WORD CALLBACK ReadCounterMaxValue_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // 0: for Counter 0,  1: for Counter 1
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 
//---------------------- output ------------------------------------
                         // wIPBUF[7]  Hi-Word of counter value
                         // wIPBUF[8]  Lo-Word of counter value


EXPORTS WORD CALLBACK SetCounterMaxValue_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[], double MaxValue);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // dosen't matter
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 
// MaxValue    Setting the Counter's Max Value


EXPORTS WORD CALLBACK ReadAlarmLimitValue_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // 0: for Counter 0,  1: for Counter 1
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 
//---------------------- output ------------------------------------
// wIPBUF[7]  Hi-Word of counter value
// wIPBUF[8]  Lo-Word of counter value


EXPORTS WORD CALLBACK SetAlarmLimitValue_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[], double AlarmValue);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // when in 9080 alarm mode(mode 0)
//                                      0:   To set Counter 0 alarm value
//                              1:   To set Counter 1 alarm value
//                               // when in 9080D alarm mode(mode 0)
//                                      0:   To set Counter 0 high alarm value
//                                      1:   To set Counter 0 high-high alarm value
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 


EXPORTS WORD CALLBACK EnableCounterAlarm_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // 0: counter 0 enable, 1: counter 1 enable
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 

EXPORTS WORD CALLBACK DisableCounterAlarm_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // dosen't matter 
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string


EXPORTS WORD CALLBACK EnableCounterAlarm_9080D(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // 0: for momentary, 1: for latch
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string

EXPORTS WORD CALLBACK DisableCounterAlarm_9080D(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // dosen't matter 
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 

EXPORTS WORD CALLBACK ReadCounterStatus_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // 0: for Counter 0,  1: for Counter 1
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 
//---------------------- output ------------------------------------
// wIPBUF[7]  0: Counting   1: Not Counting

EXPORTS WORD CALLBACK ClearCounter_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // 0: for Counter 0,  1: for Counter 1
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 


EXPORTS WORD CALLBACK ReadOutputAlarmState_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // dosen't matter 
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 
//---------------------- output ------------------------------------
   // wIPBUF(7):0  for 9080 ->  Counter0:Disable   Counter1:Disable
   // wIPBUF(7):1               Counter0:Disable   Counter1:Enable
   // wIPBUF(7):2               Counter0:Enable    Counter1:Disable
   // wIPBUF(7):3               Counter0:Enable    Counter1:Enable
   // wIPBUF(7):0  for 9080D ->  Counter0:Disable
   // wIPBUF(7):1                Counter0:Momentary
   // wIPBUF(7):2                Counter0:Latch
   // wIPBUF(8):0    Bit:1 Disable  Bit 0: Disable
   // wIPBUF(8):1    Bit:1 Disable  Bit 0: Enable
   // wIPBUF(8):2    Bit:1 Enable   Bit 0: Disable
   // wIPBUF(8):3    Bit:1 Enable   Bit 0: Enable


EXPORTS WORD CALLBACK SetInputSignalMode_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // Counter 0's and 1's signal mode
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string
//---------------------- Input -------------------------------------
                    // wIPBUF(5):0    Counter:0 TTL      Counter:0  TTL
                    // wIPBUF(5):1    Counter:1 Photo    Counter:1  Photo
                    // wIPBUF(5):2    Counter:0 TTL      Counter:1  Photo
                    // wIPBUF(5):3    Counter:1 Photo    Counter:0  TTL


EXPORTS WORD CALLBACK ReadInputSignalMode_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
// wIPBUF[0];             // 1/2/3/4 : for RS-232 port number 
// wIPBUF[1];             // 00 to FF : for module address 
// wIPBUF[2];             // module ID: for 0x9080
// wIPBUF[3];             // 0=disable, 1=enable : for checksum 
// wIPBUF[4];             // normal=100 : for TimeOut constant
// wIPBUF[5];             // dosen't matter 
// wIPBUF[6];             // 0=no save, 1=save : for flag send/receive string 
//---------------------- output ------------------------------------
                    // wIPBUF(7):0    Counter:0 TTL      Counter:0  TTL
                    // wIPBUF(7):1    Counter:1 Photo    Counter:1  Photo
                    // wIPBUF(7):2    Counter:0 TTL      Counter:1  Photo
                    // wIPBUF(7):3    Counter:1 Photo    Counter:0  TTL


/* ------------ 9080 Preset Counter 0/1 Counter Value ---------------- */
EXPORTS WORD CALLBACK PresetCounterValue_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[], double PresetValue);

/* ------------ 9080 Read Preset Counter 0/1 Counter Value ------------- */
EXPORTS WORD CALLBACK ReadPresetCounterValue_9080(WORD wIPBUF[], float fOPBUF[],
                            char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- output ------------------------------------
                      // wIPBUF[7]= Hi-Word of Preset Counter Value
                      // wIPBUF[8]= Lo-Word of Preset Counter Value

/*-------- 9080 Start Counting ---------*/
EXPORTS WORD CALLBACK StartCounting_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9080
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // 0: for Counter 0   1: for Counter 1
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//wIPBUF[7];   // 0: for Stop Counting  1: for Start Counting


/*-------- Set 9080 module mode  ---------*/
EXPORTS WORD CALLBACK SetModuleMode_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9080
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // 0: for 9080 mode   1: for 9080D mode
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string

/*-------- Read 9080 module mode  ---------*/
EXPORTS WORD CALLBACK ReadModuleMode_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9080
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // dosen't matter 
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//------------------ output ---------------------
//wIPBUF[5]= 0: for 9080 mode,  1: for 9080D mode


/*-------- 9080 Set Level Volt ---------*/
EXPORTS WORD CALLBACK SetLevelVolt_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9080
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // 0: for Low Level,  1: for High Level
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//fOPBUF[0];   // Level Voltage


/*-------- 9080 Read Level Volt ---------*/
EXPORTS WORD CALLBACK ReadLevelVolt_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input ------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9080
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // 0: for Low Level,  1: for High Level
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//----------------------- output ----------------------------------
//fOPBUF[0];        // Level Voltage


/* -------------- 9080 Set Min Signal Width ------------------------- */
EXPORTS WORD CALLBACK SetMinSignalWidth_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[], long MinWidth);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9080
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // 0: for Low Level,  1: for High Level
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//MinWidth     // the Input Signal of Min Width

/* -------------- 9080 Read Min Signal Width ------------------------- */
EXPORTS WORD CALLBACK ReadMinSignalWidth_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input ----------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9080
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // 0: for Low Level,  1: for High Level
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//---------------------- Output ---------------------------------
//wIPBUF[7]    // the Reading Input Signal of Min Width


/* -------------- 9080 Set Gate Mode ------------------------- */
EXPORTS WORD CALLBACK SetGateMode_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9080
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[5];   // 0: for Low,  1: for High,  2: for None
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 

/* -------------- 9080 Read Gate Mode ------------------------- */
EXPORTS WORD CALLBACK ReadGateMode_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input ---------------------------------
//wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wIPBUF[1];   // 00 to FF : for module address 
//wIPBUF[2];   // module ID: for 0x9080
//wIPBUF[3];   // 0=disable, 1=enable : for checksum 
//wIPBUF[4];   // normal=100 : for TimeOut constant
//wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string
//---------------------- output --------------------------------
//wIPBUF[5];   // 0: for Low,  1: for High,  2: for None


/*-------- 9080 Send data to LED  ---------*/
EXPORTS WORD CALLBACK DataToLED_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//---------------------- input -------------------------------------
//wPort=(char)wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wAddr=wIPBUF[1];         // 00 to FF : for module address 
//wID=wIPBUF[2];           // module ID: for 0x9080
//wCheckSum=wIPBUF[3];     // 0=disable, 1=enable : for checksum 
//wTimeOut=wIPBUF[4];      // normal=100 : for TimeOut constant
//wCounter=wIPBUF[5];      // dosen't matter 
//wFlag=(char)wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//fOutValue=fOPBUF[0];     // Data to LED


/*-------- Set configuration for 9080 ---------*/
EXPORTS WORD CALLBACK SetConfiguration_9080(WORD wIPBUF[], float fOPBUF[],
        char szSendTo9000[], char szReceiveFrom9000[]);
//*** Notice: if you change the Baudrate or Checksum, please short the INIT*(pin6) to GND(pin10)
//---------------------- input -------------------------------------
//wPort=(char)wIPBUF[0];   // 1/2/3/4 : for RS-232 port number 
//wAddrOld=wIPBUF[1];      // 00 to FF : for module address 
//wID=wIPBUF[2];           // module ID: for 0x9080
//wCheckSumOld=wIPBUF[3];          // 0=disable, 1=enable: for  module original checksum 
//wTimeOut=wIPBUF[4];      // normal=100 : for TimeOut constant
//wFreqGateTime=wIPBUF[5]; // desired frequency gate time:
                           //      0: for 0.1 second
                           //      1: for 1.0 second
                           // dosen't matter wIPBUF[5],if set the module into Counter mode
//wFlag=(char)wIPBUF[6];   // 0=no save, 1=save : for flag send/receive string 
//wAddrNew=wIPBUF[7];      // desired new address
//wType=wIPBUF[8];         // desired Type->  0: for Counter mode
                          //                  1: for Frequency mode
//wBaudrate=wIPBUF[9];     // desired Baudrate:
                          //    3: 1200 BPS    4:  2400 BPS
                          //    5: 4800 BPS    6:  9600 BPS
                          //    7: 19200 BPS   8:  38400 BPS
                          //    9: 57600 BPS   10: 115200 BPS
//wCheckSumNew=wIPBUF[10]; // desired Checksum Address



